# Components

DeTEE is built of multiple components that are already under development, as follows:
- **The Brain**: a decentralized contract manager (functioning very much like an Oracle) that runs on top of the DeTEE encryption layer
  - [x] stores your account balance (no matter if you are a user or a node operator)
  - [x] allows you to create contracts for VMs and containers
  - [ ] allows you to create contracts for GPUs
  - [ ] allows users to vote for the upgrades of the platform
  - [x] stores ratings for users and servers
  - [ ] allows you to deposit and withdraw DeTEE tokens via different blockchains
    - during the testnet phase, Loyalty Points (LP) will be used instead of DeTEE Tokens

- **(Intel) SGX Daemon**: Software that powers the SGX node, allowing customers to run containers
  - [x] allows you to run containers based on [occlum](https://github.com/occlum/occlum)
  - [x] allows you to expose ports on the public IP of the node
  - [ ] offers domain services and TLS termination based on intel SGX
  - [x] allows payment model based on reservation of hardware

- **(AMD) SNP Daemon**: Software that powers the SNP node, allowing customers to run VMs
  - [x] allows you to run VMs using ArchLinux, Ubuntu and Fedora as a base
  - [x] allows you to expose ports on the public IP of the node
  - [x] allows dedicated public IPv4 and public IPv6 addresses for the VMs
  - [x] allows payment model based on reservation of hardware

- **DeTEE CLI**: end-user CLI that allows you manage resources on the DeTEE platform
  - [x] allows you to manage your account data
  - [x] allow you to manage VMs
  - [x] allow you to manage containers
  - [ ] offers warning about containers and VMs facing performance issues or decommissioning
  - [ ] enables withdrawal of tokens to public blockchains
  - [ ] manage access to resources based on teams

- **DeTEE Web GUI**: Will offer the same features as the CLI in a user friendly manner

- **Orchestrator**: advanced cloud service that offers high availability and clustering for software services running on the DeTEE platform
  - [ ] management of secrets using DeTEE encryption
  - [x] deployment of swarms of containers across multiple nodes
  - [ ] create groups of highly available VMs based on the same template
  - [ ] automatic scaling of resources based on load
  - [ ] automatic migration of resources in case of hardware failure (or decommissioning)
  - [ ] multi-region clusters

Future components (currently not under development):
- **(ARM) TrustZone Daemon**: Software that powers the SNP node, allowing customers to run VMs
- **(NVIDIA) GPU Daemon**: Software that powers the SNP node, allowing customers to run VMs

<script type="text/javascript" id="hcb" src="/js/comments.js"></script><div id="HCB_comment_box"></div><link rel="stylesheet" type="text/css" href="/css/comments.css"/>
