# Quick Start

Before proceeding, make sure you have met the [prerequisites](./prerequisites.md).\
Hacker challenge works as a cluster that anybody can join. To join a cluster you need
to run the DeTEE Hacker Challenge node (for simplicity we call it dthc):

```bash
docker run --device /dev/sgx/enclave --device /dev/sgx/provision --env INIT_NODES="212.95.45.139 46.165.199.12 184.107.183.210" -v /tmp/dthc:/challenge/main -p 80:31372 -p 31373:31373 -d  --name dthc detee/hacker-challenge:latest
```

Note.
- the devices are mandatory to give node the access to the SGX driver
- `INIT_NODES` are current nodes so that your node can interact with the cluster,
  we keep them up to date
- in the /tmp/dthc you will find the file where the node writes Solana keys, it's called `TRY_TO_HACK_THIS`
- port 31373 is needed if you have a public IP and want other nodes to connect to you
- port 80 is the web interface of your node, it has `/nodes`, `/metrics` and `/mint?address=...` endpoints

After your node has started, feel free to start exploring logs in `docker logs <hash>`

<script type="text/javascript" id="hcb" src="/js/comments.js"></script><div id="HCB_comment_box"></div><link rel="stylesheet" type="text/css" href="/css/comments.css"/>